﻿// Compiler options:  /unsafe /optimize /debug- /target:library /out:"C:\Program Files\Paint.NET\Effects\PasteFill.dll"
using System;
using System.Text;
using System.Windows;
using System.Reflection;
using System.Windows.Forms;
using PaintDotNet;
using PaintDotNet.Effects;
using PaintDotNet.IndirectUI;
using PaintDotNet.PropertySystem;
using System.Collections.Generic;
using System.Drawing;
using System.Drawing.Imaging;
using System.Drawing.Text;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

[assembly: AssemblyTitle("TR's Copy with Alpha")]
[assembly: AssemblyDescription("")]
[assembly: AssemblyConfiguration("")]
[assembly: AssemblyCompany("TehcnoRobbo")]
[assembly: AssemblyProduct("TR's Copy with Alpha")]
[assembly: AssemblyCopyright("© TehcnoRobbo 2014")]
[assembly: AssemblyTrademark("")]
[assembly: AssemblyCulture("")]
[assembly: ComVisible(false)]
[assembly: AssemblyVersion("1.0")]

namespace CopyAlpha
{
    public class PluginSupportInfo : IPluginSupportInfo
    {
        public string Author
        {
            get
            {
                return "TechnoRobbo";
            }
        }
        public string Copyright
        {
            get
            {
                return ((AssemblyCopyrightAttribute)base.GetType().Assembly.GetCustomAttributes(typeof(AssemblyCopyrightAttribute), false)[0]).Copyright;
            }
        }

        public string DisplayName
        {
            get
            {
                return ((AssemblyProductAttribute)base.GetType().Assembly.GetCustomAttributes(typeof(AssemblyProductAttribute), false)[0]).Product;
            }
        }

        public Version Version
        {
            get
            {
                return base.GetType().Assembly.GetName().Version;
            }
        }

        public Uri WebsiteUri
        {
            get
            {
                return new Uri("http://www.technorobbo.com");
            }
        }
    }

    [PluginSupportInfo(typeof(PluginSupportInfo), DisplayName = "PasteFill")]
    public class CopyAlphaPlugin : PropertyBasedEffect
    {
        public static string StaticName
        {
            get
            {
                return "TR's Copy with Alpha";
            }
        }

        public static Image StaticIcon
        {
            get
            {
                return null;
            }
        }

        public CopyAlphaPlugin()
            : base(StaticName, StaticIcon, "Selection", EffectFlags.None)
        {
        }


        protected override PropertyCollection OnCreatePropertyCollection()
        {
            List<Property> props = new List<Property>();

            return new PropertyCollection(props);
        }
        //============
        

        public PaintDotNet.Surface CBoard= null;

        public void SetImageToClipboard()
        {

            try
            {
                System.Windows.Forms.Clipboard.SetImage((Image)CBoard.CreateAliasedBitmap());
            }
            catch (Exception) { }
        }

        public void GetImageFromClipboard()
        {

            try
            {
                if (System.Windows.Forms.Clipboard.ContainsImage())
                {
                    //DataFormats.Format df = DataFormats.GetFormat(DataFormats.Dib);
                    CBoard = PaintDotNet.Surface.CopyFromGdipImage(System.Windows.Forms.Clipboard.GetImage());
                }
            }
            catch (Exception) { }
        }

        protected override void OnSetRenderInfo(PropertyBasedEffectConfigToken newToken, RenderArgs dstArgs, RenderArgs srcArgs)
        {
            CBoard = srcArgs.Surface;

            System.Threading.Thread t = new System.Threading.Thread(new System.Threading.ThreadStart(SetImageToClipboard));
            t.SetApartmentState(System.Threading.ApartmentState.STA);
            t.Start();
            t.Join();


                //System.Threading.Thread t = new System.Threading.Thread(new System.Threading.ThreadStart(GetImageFromClipboard));
                //t.SetApartmentState(System.Threading.ApartmentState.STA);
                //t.Start();
                //t.Join();

            base.OnSetRenderInfo(newToken, dstArgs, srcArgs);
        }


        #region UICode
        #endregion


        protected override unsafe void OnRender(Rectangle[] rois, int startIndex, int length)
        {
            if (length == 0) return;
            for (int i = startIndex; i < startIndex + length; ++i)
            {
                MyRender(DstArgs.Surface, SrcArgs.Surface, CBoard, rois[i]);
            }

        }
        
        
        void MyRender(PaintDotNet.Surface dst, PaintDotNet.Surface src,PaintDotNet.Surface clip, Rectangle rect)
        {
          
     
            
            for (int y = rect.Top; y < rect.Bottom; y++)
            {
                for (int x = rect.Left; x < rect.Right; x++)
                {

                    if (clip == null)
                    {
                        dst[x, y] = src[x, y];
                    }
                    else
                    {

                        ColorBgra CO = clip.GetBilinearSampleWrapped(x, y);
                        ColorBgra CP = src[x, y];
                        double alpha = (double)CO.A / 255f;
                        double r = (double)CO.R * alpha + (double)CP.R - (double)CP.R * alpha;
                        double g = (double)CO.G * alpha + (double)CP.G - (double)CP.G * alpha;
                        double b = (double)CO.B * alpha + (double)CP.B - (double)CP.B * alpha;
                        ColorBgra CN = ColorBgra.FromBgra((byte)b, (byte)g, (byte)r, CP.A); 
                        dst[x, y]= CN;
                    }
                    
                 }
            }
        }
        
    }
}


